#include <SoftwareSerial.h>
#define SPEED 255 //0-255
SoftwareSerial BT(2,3);//เชื่อมต่อกับ Bluetooth แบบ Serial ที่ขา 2,3 ซึ่ง ขา 2 เป็นขา RX และขา 3 เป็นขา TX

struct driveMotor{ //สร้างโครงสร้างตัวแปร driveMotor
  int in1;
  int in2;
  int pwm;
};

driveMotor motor[2]={{A0,A1,5},{A2,A3,6}}; //ประกาศตัวแปรแบบโครงสร้าง driveMotor ชื่อมอเตอร์เป็นตัวแปรแบบ Array มีสมาชิกสองตัวเป็นตัวแทนมอเตอร์ 2 ตัว ซึ่งมอเตอร์ 1 ตัวใช้ relay 2 ตัวในการควบคุม

void setup(){
  pinMode(motor[0].in1,OUTPUT);//กำหนดขาที่ควบคุมมอเตอร์ทั้งหมดเป็นเอาต์พุต
  pinMode(motor[0].in2,OUTPUT);
  pinMode(motor[0].pwm,OUTPUT);
  
  pinMode(motor[1].in1,OUTPUT);
  pinMode(motor[1].in2,OUTPUT);
  pinMode(motor[1].pwm,OUTPUT);
  
  BT.begin(9600); //กำหนดอัตราการสื่อสารกับ Bluetooth ที่ 9600bps

}

void loop(){
  if(BT.available()){
    char c=BT.read();
    if(c=='F')forward();
    else if(c=='B')reward();
    else if(c=='L')turnleft();
    else if(c=='R')turnright();
    else if(c=='S')robotStop();
  }
}

void forward(){//เดินหน้า
  motorRun(0,'a');//มอเตอร์ 0 หมนทวนเข็มนาฬิกา a:anti clock witch
  motorRun(1,'c');//มอเตอร์ 1 หมนตามเข็มนาฬิกา c:clock witch
}
void reward(){//ถอยหลัง
  motorRun(0,'c');
  motorRun(1,'a');
}

void turnleft(){//เหลี่ยวซ้าย
  motorRun(0,'c');
  motorRun(1,'c');
}

void turnright(){//เหลี่ยวขวา
  motorRun(0,'a');
  motorRun(1,'a');
}

void robotStop(){//หยุด s:stop
  motorRun(0,'s');
  motorRun(1,'s');
}

void motorRun(int motorNo,char dir){
  if(dir=='a'){ //a:anti clock witch
    digitalWrite(motor[motorNo].in1,HIGH);
    digitalWrite(motor[motorNo].in2,LOW);
  }else if(dir=='c'){ //c:clock witch
    digitalWrite(motor[motorNo].in1,LOW);
    digitalWrite(motor[motorNo].in2,HIGH);
  }if(dir=='s'){//s:stop
    digitalWrite(motor[motorNo].in1,LOW);
    digitalWrite(motor[motorNo].in2,LOW);
  }
  analogWrite(motor[motorNo].pwm,SPEED);
}
